#include <malloc.h>
//#include <stdio.h>
//#include <stdlib.h>
//#include <string.h>
//#include <ogcsys.h>
//#include <time.h>
//#include <ogc/disc_io.h>
#include <fat.h>
#include "sidestep.c"
#include "ssaram.c"
#include <sdcard/gcsd.h>
#include <dirent.h>	
#define DEVICE_HANDLER_SEEK_SET 0
#define DEVICE_HANDLER_SEEK_CUR 1

//sdGecko slot A and B
#define PATH "sda:/boot.dol"
static void *xfb = NULL;
GXRModeObj *rmode;
const DISC_INTERFACE* carda = &__io_gcsda;
typedef struct {
        char name[1024]; // File or Folder, absolute path goes here
        uint64_t fileBase;   // Only used on DVD/Wode/DVD-emulator
        unsigned int offset;    // Offset in the file
        unsigned int size;      // size of the file
        int fileAttrib;        // IS_FILE or IS_DIR
        int status;            // is the device ok
        FILE *fp;
} file_handle;


file_handle curFile =
        { "sda:/boot.dol",       // directory
          NULL,     // fileBase (u64)
          0,        // offset
          0,        // size
          1,
          0,
          0
        };


static u8 SysArea[CARD_WORKAREA] ATTRIBUTE_ALIGN(32);



void (*PSOreload)() = (void(*)())0x80001800;


/*---------------------------------------------------------------------------------
	This function is called if a card is physically removed
---------------------------------------------------------------------------------*/
void card_removed(s32 chn,s32 result) {
//---------------------------------------------------------------------------------
	printf("card was removed from slot %c\n",(chn==0)?'A':'B');
	CARD_Unmount(chn);
}

int deviceHandler_seekFile(file_handle* file, unsigned int where, unsigned int type){
        if(type == DEVICE_HANDLER_SEEK_SET) file->offset = where;
        else if(type == DEVICE_HANDLER_SEEK_CUR) file->offset += where;
        return file->offset;
}

int deviceHandler_readFile(file_handle* file, void* buffer, unsigned int length){
        if(!file->fp) {
                file->fp = fopen( file->name, "r+" );
        }
        if(!file->fp) return -1;
        
        fseek(file->fp, file->offset, SEEK_SET);
        int bytes_read = fread(buffer, 1, length, file->fp);
        if(bytes_read > 0) file->offset += bytes_read;
        
        return bytes_read;
}



int file_length(FILE *f)
{
int pos;
int end;

pos = ftell (f);
fseek (f, 0, SEEK_END);
end = ftell (f);
fseek (f, pos, SEEK_SET);

return end;


}
int main() {
void *framebuffer;

	VIDEO_Init();
	PAD_Init();
	
	rmode = VIDEO_GetPreferredMode(NULL);

	framebuffer = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(framebuffer,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(framebuffer);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

		xfb = framebuffer;
	
	printf("Memory Card Demo\n\n");

	while (1) {
		//printf("Insert A card in slot B and press A\n");

		

		//printf("Mounting card ...\n");

		CARD_Init("DEMO","00");
		int SlotA_error = CARD_Mount(CARD_SLOTA, SysArea, card_removed);
	
		//printf("slot  code %d\n",SlotA_error);

		int CardError;
		
		if (SlotA_error == -2) {
		__io_gcsda.startup();
		if (__io_gcsda.isInserted() == 1) {
		fatInitDefault();
		if (!fatMountSimple ("sda", 	carda)){
		
		}else {
	curFile.fp = fopen(curFile.name,"r+");	
	curFile.size = file_length(curFile.fp);
	unsigned char *dol_buffer;
        unsigned char *ptr;
       dol_buffer = (unsigned char*)memalign(32,curFile.size);
        if(!dol_buffer) {
           //    main();
        }
                
        int i=0;
        ptr = dol_buffer;
        for(i = 0; i < curFile.size; i+= 131072) {
                 
                deviceHandler_seekFile(&curFile,i,DEVICE_HANDLER_SEEK_SET);
                int size = i+131072 > curFile.size ? curFile.size-i : 131072; 
                if(deviceHandler_readFile(&curFile,ptr,size)!=size) {
                  
                        //main();
                }
                ptr+=size;
        }
        
        DOLtoARAM(dol_buffer);
}

			
		}
		}else {
			//printf("error no sd insert");
		}
	}

}


